#include "bhv_line_defense.h"

#include <rcsc/player/player_agent.h>
#include <rcsc/action/bhv_go_to_point_look_ball.h>

using namespace rcsc;

bool BhvLineDefense::execute ( PlayerAgent* agent )
{
    /* Assumptions
     1) Team is defending
     2) Self is one of the defenders
     */

    double our_defense_line = agent->world().ourDefenseLineX();

    switch ( agent->world().ourSide() )
    {
        case LEFT:
        {
            if ( agent->world().self().pos().x < our_defense_line )
            {
                // Move towards the x-coordinate of the defense line
                // Which y-coordinate should be chosen? Consider existing opponents near our defemse line
                // CAREFUL Nearest opponent to self might even be nearer to another teammate
                // TODO Should create a mark table in the world state to decide this
                return Bhv_GoToPointLookBall(Vector2D(our_defense_line, agent->world().self().pos.y ),
                                      0.1,
                                      agent->world().self().playerType().dashPowerRate())
                        .execute( agent );
            }

            break;
        }
        case RIGHT:
        {
            if ( agent->world().self().pos().x < our_defense_line )
            {
                // Move towards the x-coordinate of the defense line
                // Which y-coordinate should be chosen? Consider existing opponents near our defemse line
                // CAREFUL Nearest opponent to self might even be nearer to another teammate
                // TODO Should create a mark table in the world state to decide this
                return Bhv_GoToPointLookBall(Vector2D(our_defense_line, agent->world().self().pos.y ),
                                      0.1,
                                      agent->world().self().playerType().dashPowerRate())
                        .execute( agent );
            }
        }
        break;
    }


}
