#include "bhv_mark_player.h"

#include <rcsc/player/player_agent.h>
#include <bhv_basic_tackle.h>

#include <rcsc/common/logger.h>

using namespace rcsc;

BhvMarkMan::BhvMarkMan(const rcsc::AbstractPlayerObject *man_to_mark,
                       double mark_distance)
    : M_man_to_mark( man_to_mark )
    , M_mark_distance( mark_distance )
{

}

bool BhvMarkMan::execute(rcsc::PlayerAgent *agent)
{
    // TODO Decide logic to mark a player by the agent
    // Assume that the chosen player to mark is already the best one

    double dist = agent->world().self().pos().dist(M_man_to_mark->pos());


    // Try to kick the ball
    if ( doKick( agent ) )
    {
        dlog.addText( Logger::MARK,
                      __FILE__ " BhvMarkPlayer: Kicked the ball away from attacker %d ",
                      M_man_to_mark->unum());
        return true;
    }

    // Tackle the player to mark
    if ( doTackle( agent ))
    {
        dlog.addText( Logger::MARK,
                      __FILE__ " BhvMarkPlayer: Tackled attacker %d ",
                      M_man_to_mark->unum());
        return true;
    }

    // Move towards the player to mark
    if ( doMove() )
    {
        dlog.addText( Logger::MARK,
                      __FILE__ " BhvMarkPlayer: Moving towards attacker #%d (%.2f.%.2f)",
                      M_man_to_mark->unum(),
                      M_man_to_mark->pos().x, M_man_to_mark->pos().y);
        return true;
    }

    return false;

}


bool BhvMarkMan::doMove(rcsc::PlayerAgent* agent)
{
    // TODO
}

bool BhvMarkMan::doTackle(rcsc::PlayerAgent* agent)
{
    return Bhv_BasicTackle( 0.8, 90.0 ).execute( agent );
}

bool BhvMarkMan::doKick(rcsc::PlayerAgent* agent)
{
    // TODO
}

