#include "actgen_pass_open_space_dt.h"

#include "field_analyzer.h"
#include <rcsc/geom/triangle_2d.h>
#include <rcsc/player/intercept_table.h>

#include "cooperative_action.h"
#include "pass.h"

using namespace rcsc;
ActGenPassOpenSpaceDT::ActGenPassOpenSpaceDT()
{

}


void ActGenPassOpenSpaceDT::generate( std::vector< ActionStatePair > * result,
                                       const PredictState & state,
                                       const rcsc::WorldModel & wm,
                                       const std::vector< ActionStatePair > & path ) const {

    // Min triangle area
    float TRIANGLE_AREA_MIN = 5 * rcsc::ServerParam::defaultPlayerSize();

    const rcsc::DelaunayTriangulation opp_dt = FieldAnalyzer::instance().opponentsDT();

    // Check if ball is kickable by one of our players
    const AbstractPlayerObject* ball_holder = state.ballHolder();

    if ( ball_holder == NULL ) {
        return;
    }

    if ( wm.time().cycle() == 0 )
        return; // No calculations for cycle 0

    for ( rcsc::DelaunayTriangulation::TriangleCont::const_iterator it_tri = opp_dt.triangles().begin();
          it_tri != opp_dt.triangles().end();
          it_tri++)
    {
        DelaunayTriangulation::Triangle* triangle = (*it_tri).second;
        rcsc::Triangle2D triangle2d(triangle->vertex(0)->pos(),
                                    triangle->vertex(1)->pos(),
                                    triangle->vertex(2)->pos());

        // Inneficient implementation
        for ( PredictPlayerPtrCont::const_iterator it_our =  state.ourPlayers().begin();
              it_our != state.ourPlayers().end();
              it_our++) {
            PredictPlayerObject::Ptr our_player = *it_our;
            if ( our_player->isSelf() ) {

            }
        }

        if ( triangle2d.area() >= TRIANGLE_AREA_MIN ) {
            Vector2D pass_target = triangle2d.centroid();

            // CooperativeAction::Ptr pass = new Pass( );
            const PlayerObject* player_closest_to_target;
            double ball_time_to_target = BallObject::calc_travel_step(wm.ball().pos().dist(pass_target),
                                                                      wm.ball().vel());
            // Ball time to


            // Closest player to the pass_


        }


    }
}
