#ifndef FCPORTUGAL_DPRE_H
#define FCPORTUGAL_DPRE_H

#include <strategy/singleton.h>
#include <strategy/dpre.h>

class FCPortugalPlayer;

namespace fcportugal {

    class DPRE
        : public soccer::strategy::DPRE
	{
    public:

        static DPRE& instance();

        void update();
        void setAgent( const FCPortugalPlayer* agent );
    private:
	    DPRE();
        ~DPRE();


    protected:
        /*!
          \brief Retrieve the list of positionings that were changed in the last analysis
          */
        void positioningsChanged(Positionings changed_positionings);

        /*!
        \brief Verify if player should be consider for DPRE
        \return True if the player is to be considered or false otherwise
         */
        const std::vector<unsigned int>& eligiblePlayers(  ) ;

        /*!
          \brief Value of exchanging the positionings of 2 players
          \return True if it is useful to exchange player positionings
          */
        double exchangeValue(unsigned int number1,
                             unsigned int number2) const;

    private:
        const FCPortugalPlayer* M_agent;
        std::vector<unsigned int> M_eligible_players;
    };

}

#endif
