#ifndef MATCH_STATISTICS_H
#define MATCH_STATISTICS_H

#include <map>

class MatchStatistics
{
public:

    MatchStatistics();

    void ourPassMissed( unsigned int time );
    void oppPassMissed( unsigned int time );

    void ourPossession( unsigned int from, unsigned int to );
    void oppPossession( unsigned int from, unsigned int to );

    double ourPassMissRatio( );
    double oppPassMissRatio( );


    double ourBallPossession( );
    double oppBallPossession( );

private:
    // Passes statistics
    unsigned int M_our_pass_attempts;
    unsigned int M_our_pass_successes;
    unsigned int M_our_last_pass_missed_time;

    unsigned int M_opp_pass_attempts;
    unsigned int M_opp_pass_successes;
    unsigned int M_opp_last_pass_missed_time;

    // Ball possession statistics
    unsigned int M_our_ball_possession;
    unsigned int M_opp_ball_possession;

    // Analyze attacking behavior => Shoots on goal
    unsigned int M_our_shots_off_goal;
    unsigned int M_our_shots_off_goal;

};

#endif // MATCH_STATISTICS_H
