/* -*- Mode: C++ -*- */
/* Planning.h
 * F.C.Portugal
 * Luis Paulo Reis - Nuno Lau 2003
 */

#ifndef FCPORTUGAL_PLANNING_H
#define FCPORTUGAL_PLANNING_H

#include <vector>
#include <rcsc/geom/vector_2d.h>
#include <rcsc/game_time.h>
#include <boost/shared_ptr.hpp>

#include <setplay/runtime/setplay_mediator.h>

class FCPortugalPlayer;

namespace fcportugal {

    class SetplayWorldModel;

    class Planner
            : public ::setplay::SetplayMediator
    {
    public:
        typedef boost::shared_ptr< Planner > Ptr;
        typedef boost::shared_ptr< const Planner > ConstPtr;

        Planner(FCPortugalPlayer* agent);
        ~Planner();

        // virtual ::setplay::Setplay* feasible_setplay() = 0;

        ::setplay::IMessage* messageToSend() const { return NULL; }
        // SetplayExecutor overrides
        /*!
          \brief Delegate the analysis of feasible setplays to the implementor
          */
        std::vector<int> feasible_setplays();

        bool init( );

        void execute( );

        void initGlobals();
    protected:


        void decisionStartPlan( );

    private:
        FCPortugalPlayer* M_agent;
    };

}
#endif // FCPORTUGAL_PLANNING_H
