#include "action_done_message.h"

namespace setplay {

    ActionDoneMessage::ActionDoneMessage(const PlayerAffiliation &sender,
                                         unsigned int time,
                                         unsigned int setplay_id, bool inverted)
        : IMessage(sender,
                   time,
                   setplay_id, inverted)
    {

    }

    ActionDoneMessage::ActionDoneMessage(const ActionDoneMessage& other)
        : IMessage(other)
    {

    }

    ActionDoneMessage::~ActionDoneMessage()
    {

    }

    MessageType ActionDoneMessage::type() const
    {
        return MSG_ACTION_DONE;
    }

    void ActionDoneMessage::getProcessed(IMessageProcessor& processor) const
    {
        processor.process( *this );
    }

    ActionDoneMessage* ActionDoneMessage::clone() const
    {
        return new ActionDoneMessage( *this );
    }

}
