#ifndef SP_IMESSAGE_PROCESSOR_H
#define SP_IMESSAGE_PROCESSOR_H

namespace setplay {
    class SetplayStartMessage;
    class StepEnterMessage;
    class StepTransitionMessage;
    class ActionDoneMessage;
    class SetplayFinishMessage;
    class SetplayAbortMessage;

    class IMessageProcessor
    {
    public:
        virtual ~IMessageProcessor();

        virtual void process(const SetplayStartMessage& message) = 0;
        virtual void process(const StepTransitionMessage& message) = 0;
        virtual void process(const StepEnterMessage& message) = 0;
        virtual void process(const ActionDoneMessage& message) = 0;
        virtual void process(const SetplayFinishMessage& message) = 0;
        virtual void process(const SetplayAbortMessage& message) = 0;

    };

}
#endif // IMESSAGE_RECEIVER_H
