#include "setplay_finish_message.h"


namespace setplay {

    SetplayFinishMessage::SetplayFinishMessage(const PlayerAffiliation &sender, unsigned int time, unsigned int setplay_id, bool inverted)
    : IMessage(sender, time, setplay_id, inverted)
    {

    }

    SetplayFinishMessage::SetplayFinishMessage(const SetplayFinishMessage& other)
        : IMessage(other)
    {

    }

    SetplayFinishMessage::~SetplayFinishMessage()
    {

    }

    MessageType SetplayFinishMessage::type() const
    {
        return MSG_FINISH;
    }

    void SetplayFinishMessage::getProcessed(IMessageProcessor& processor) const
    {
        processor.process( *this );
    }

    SetplayFinishMessage* SetplayFinishMessage::clone() const
    {
        return new SetplayFinishMessage( *this );
    }

    void SetplayFinishMessage::print(std::ostream& os) const
    {
        os << "SetplayFinishMessage" << std::endl;
        IMessage::print( os );
    }

}
