#include "step_enter_message.h"

namespace setplay {

StepEnterMessage::StepEnterMessage(const PlayerAffiliation& sender,
                                   unsigned int time,
                                   unsigned int setplay_id,
                                   unsigned int step_id, bool inverted)
    : IMessage(sender, time, setplay_id, inverted)
    , M_step_id( step_id )
{

}

StepEnterMessage::StepEnterMessage(const StepEnterMessage& other)
    : IMessage( other )
    , M_step_id( other.M_step_id )
{

}

StepEnterMessage::~StepEnterMessage()
{

}

unsigned int StepEnterMessage::stepId() const
{
    return M_step_id;
}

void StepEnterMessage::setStepId( unsigned int step_id )
{
    M_step_id = step_id;
}

void StepEnterMessage::getProcessed(IMessageProcessor& processor) const
{
    processor.process(*this);
}

MessageType StepEnterMessage::type() const
{
    return MSG_STEP_ENTER;
}

IMessage* StepEnterMessage::clone() const
{
    return new StepEnterMessage( *this );
}

void StepEnterMessage::print(std::ostream& os) const
{
    os << "StepEnterMessage" << std::endl;
    IMessage::print(os);
    os << std::endl;
    os << "Step: " << M_step_id << std::endl;
}

}
