// -*-c++-*-
#ifndef SP_STEP_TRANSITION_MESSAGE_H
#define SP_STEP_TRANSITION_MESSAGE_H

#include <setplay/communication/imessage.h>

using namespace std;

namespace setplay {

    class StepTransitionMessage
            : public IMessage {
    public:
      StepTransitionMessage(const PlayerAffiliation& sender,
                            unsigned int time,
                            unsigned int setplayId,
                            unsigned int currentStepId = 0,
                            unsigned int nextStepId = 0,
                            bool inverted = false);
      StepTransitionMessage(const StepTransitionMessage& other);
      virtual ~StepTransitionMessage();

      MessageType type() const;

      void getProcessed(IMessageProcessor& processor) const;

      // TODO This message should be changed to identify only the next step id (Manager must keep track of current step)
      unsigned int currentStepId() const;
      unsigned int nextStepId() const;

      void setCurrentStepId( unsigned int current_step_id );
      void setNextStepId( unsigned int next_step_id );

      StepTransitionMessage* clone() const;
      void print(std::ostream& os) const;
    private:
      unsigned int M_current_step_id;
      unsigned int M_next_step_id;
    };

}

#endif
