// -*-c++-*-

/***************************************************************************
                                act_intercept.h
                       Abstract base class for CLang IActions
                             -------------------
    begin                : 28-MAY-2002
    copyright            : (C) 2006 Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                        *
 *                                                                         *
 ***************************************************************************/
#ifndef SP_ACTION_INTERCEPT_H
#define SP_ACTION_INTERCEPT_H

#include <setplay/model/actions/iaction.h>
#include <setplay/model/object.h>

using namespace std;

namespace setplay {


    // Actively intercept a target
    class ActIntercept
            : public IAction {
    public:
            ActIntercept(IMobileObject* target);
            ActIntercept(const ActIntercept& other);

            ~ActIntercept();

            TokenType type() const;
            ActionType actionType() const;

            IMobileObject *target() const;

            ActIntercept& setTarget(IMobileObject* target);
            ActIntercept& operator=(const ActIntercept& other);

            ActIntercept& operator*();
            ActIntercept* clone() const;
            void visit(IVisitor& visitor);
    protected:
            IMobileObject* M_target;
    };

}

#endif
