#include "act_look_at.h"

#include <setplay/model/ivisitor.h>

#include <iostream>
#include <setplay/generators/sexpr/setplay_generator_sexpr.h>

namespace setplay {

ActLookAt::ActLookAt( std::vector<IPlayer*> players )
    : M_players( players )
{

}

ActLookAt::ActLookAt( IPlayer* player )
{
    M_players.push_back( player );
}

ActLookAt::ActLookAt( const ActLookAt& other )
{
    for ( std::vector<IPlayer*>::const_iterator itp = other.M_players.begin(); itp != other.M_players.end() ; itp++ )
    {
        M_players.push_back( (*itp)->clone() );
    }
}

ActLookAt::~ActLookAt()
{
    for ( std::vector<IPlayer*>::iterator itp = M_players.begin(); itp != M_players.end(); itp++ )
    {
        delete *itp;
    }
}

TokenType ActLookAt::type() const
{
    return TT_ACTION_LOOK_AT;
}

IAction::ActionType ActLookAt::actionType() const
{
    return IAction::AT_LOOK_AT;
}

ActLookAt& ActLookAt::operator*()
{
    return *this;
}

const vector<IPlayer*>& ActLookAt::players() const
{
    return M_players;
}

ActLookAt* ActLookAt::clone() const
{
    return new ActLookAt( *this );
}

void ActLookAt::visit(IVisitor &visitor)
{
    visitor.visit( *this );
}

}
