    // -*-c++-*-

/***************************************************************************
                                act_pass.h
                       Abstract base class for CLang IIActions
                             -------------------
    begin                : 28-MAY-2002
    copyright            : (C) 2006 Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                        *
 *                                                                         *
 ***************************************************************************/
#ifndef SP_ACTION_PASS_H
#define SP_ACTION_PASS_H

#include <setplay/model/actions/iaction.h>
#include <setplay/model/geom/ilocation.h>

#include <vector>

using namespace std;

namespace setplay {

    // Pass the ball to player(s) (argument). Pass can be done to any player
    class ActPass
            : public IAction {
    public:
        typedef enum {
            BM_NORMAL,
            BM_FAST,
            BM_SLOW,
            BM_UNDEFINED
        } BallMoveType;

        ActPass( ILocation2D* location = NULL, BallMoveType type = BM_UNDEFINED);
        ActPass( const ActPass& other);
        virtual ~ActPass();

        TokenType type() const;
        ActionType actionType() const;

        ILocation2D *location() const;
        BallMoveType ballMoveType() const;


        ActPass& setLocation(ILocation2D* location);
        ActPass& setBallMoveType(BallMoveType ball_move_type);

        void visit(IVisitor& visitor);

        ActPass& operator*();
        ActPass* clone() const;
        ActPass& operator=(const ActPass& other);
    private:
       ILocation2D* M_location;
       BallMoveType M_ball_move_type;
    };

}

#endif
