#include "act_pos.h"

#include <setplay/model/geom/ilocation.h>

#include <setplay/runtime/iaction_executor.h>
#include <setplay/runtime/iaction_evaluator.h>

#include <setplay/model/ivisitor.h>

#include <cassert>

namespace setplay {

    ActPos::ActPos( ILocation2D* r )
      : M_location( r )
    {
        assert (M_location != NULL);
    }

    ActPos::ActPos( const ActPos& action )
        : M_location( action.M_location->clone() )
    {

    }

    ActPos::~ActPos()
    {
        delete M_location;
    }

    TokenType ActPos::type() const
    {
        return TT_ACTION_POS;
    }

    IAction::ActionType ActPos::actionType() const
    {
        return AT_POS;
    }

    ILocation2D* ActPos::location() const
    {
        return M_location;
    }

    ActPos& ActPos::operator*()
    {
        return *this;
    }

    ActPos* ActPos::clone() const
    {
        return new ActPos(*this);
    }

    ActPos& ActPos::operator=(const ActPos& other)
    {
      if (this != &other)
      {
          setLocation( other.M_location != NULL ? other.M_location->clone() : NULL);
      }

      return *this;
    }

    ActPos &ActPos::setLocation(ILocation2D* location)
    {
        if ( M_location != NULL ) { delete M_location; }

        M_location = location;
        return *this;
    }

    void ActPos::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

}
