#ifndef ASSIGN_H
#define ASSIGN_H

#include <vector>

#include <setplay/model/object.h>
#include <setplay/model/operation.h>
#include <setplay/model/variable.h>

namespace setplay {

/*!
  \brief Class that represents an assignment operation which implies runtime interpretation.
 */
class Assignment
        : public Object
{
public:
    Assignment(Variable* variable = NULL, Object* expression = NULL);
    Assignment(const Assignment& other);
    ~Assignment();

    Variable* variable() const;
    Object* expression() const;

    Assignment& setVariable(Variable* variable);
    Assignment& setExpression(Object* expression);

    Assignment& operator=(const Assignment& other);

    TokenType type() const;
    Assignment* clone() const;
    void visit(IVisitor &visitor);

private:
    Variable* M_variable;
    Object* M_expression;
};

typedef std::vector<Assignment*> Assignments;


}

#endif // ASSIGN_H
