#include "cond_and.h"

#include <setplay/runtime/icondition_evaluator.h>
#include <setplay/model/ivisitor.h>

using namespace std;

namespace setplay
{

    CondAnd::CondAnd(Conditions* conditions)
    : M_conditions(conditions)
    {
        if ( M_conditions == NULL )
        {
            M_conditions = new Conditions();
        }
    }

    CondAnd::CondAnd(const CondAnd& other)
    {
        M_conditions = new Conditions();
        for ( Conditions::const_iterator itc = other.M_conditions->begin(); itc != other.M_conditions->end(); itc++)
        {
            M_conditions->push_back( (*itc)->clone() );
        }
    }

    CondAnd::~CondAnd()
    {
        for( Conditions::iterator i = M_conditions->begin();
             i != M_conditions->end();
             ++i )
        {
            delete *i;
        }
        delete M_conditions;
    }

    TokenType CondAnd::type() const
    {
        return TT_CONDITION_AND;
    }

    void CondAnd::push(ICondition* condition)
    {
        M_conditions->push_back(condition);
    }

    void CondAnd::push(Conditions* conditions)
    {
        for( Conditions::iterator i = M_conditions->begin();
             i != M_conditions->end();
             ++i )
        {
            delete *i;
        }

        for( Conditions::iterator i = conditions->begin();
             i != conditions->end();
             ++i )
        {
            M_conditions->push_back( (*i)->clone() );
        }
    }

    CondAnd& CondAnd::operator=(const CondAnd& other)
    {
        if (this != &other)
        {
            push(other.M_conditions);
        }

        return *this;
    }

    void CondAnd::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

    CondAnd* CondAnd::clone() const
    {
        return new CondAnd(*this);
    }

    CondAnd& CondAnd::operator*()
    {
        return *this;
    }

}
