#include "cond_can_dribble.h"

namespace setplay {

CondCanDribble::CondCanDribble(IPlayer* player, ILocation2D* location)
    : M_player( player )
    , M_location( location )
{

}

CondCanDribble::CondCanDribble(const CondCanDribble& other)
{
    M_player = other.M_player != NULL ? other.M_player->clone() : NULL;
    M_location = other.M_location != NULL ? other.M_location->clone() : NULL;
}

CondCanDribble::~CondCanDribble()
{
    if ( M_player != NULL ) { delete M_player; }
    if ( M_location != NULL ) { delete M_location; }
}

TokenType CondCanDribble::type() const
{
    return TT_CONDITION_CAN_PASS;
}

IPlayer* CondCanDribble::player( ) const
{
    return M_player;
}

ILocation2D* CondCanDribble::location( ) const
{
    return M_location;
}

CondCanDribble& CondCanDribble::setPlayer(IPlayer* player)
{
    if ( M_player != NULL ) { delete M_player; }
    M_player = player;
    return *this;
}

CondCanDribble& CondCanDribble::setLocation(ILocation2D* location)
{
    if ( M_location != NULL ) { delete M_location; }
    M_location = location;
    return *this;
}

CondCanDribble* CondCanDribble::clone() const
{
    return new CondCanDribble( *this );
}

CondCanDribble& CondCanDribble::operator*()
{
    return *this;
}

void CondCanDribble::visit(IVisitor& visitor)
{
    visitor.visit( *this );
}


}
