// -*-c++-*-

/***************************************************************************
                                   cond.h
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef SETPLAY_CONDITION_COMP_DECIMAL_H_
#define SETPLAY_CONDITION_COMP_DECIMAL_H_

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/operation.h>
#include <setplay/model/numbers/number_var.h>

namespace setplay {

        enum NumberComparatorOperationType
        {
            NCOT_LOWER,
            NCOT_LOWER_OR_EQUAL,
            NCOT_EQUAL,
            NCOT_GREATER,
            NCOT_GREATER_OR_EQUAL,
            NCOT_NOT_EQUAL,
            NCOT_UNDEFINED
        };

        // Condition with comparison operator to evaluate numbers
        class CondCompDecimal
                : public ICondition
                , public BinaryOperation<CondCompDecimal, IDecimal>
        {
        public:

            CondCompDecimal( NumberComparatorOperationType type,
                            IDecimal* operand_left = NULL,
                            IDecimal* operand_right = NULL);
            CondCompDecimal( const CondCompDecimal& other);
            ~CondCompDecimal();

            TokenType type() const;
            NumberComparatorOperationType operationType() const;

            CondCompDecimal* clone() const;
            CondCompDecimal& operator*();
            void visit(IVisitor& visitor);

        private:
            NumberComparatorOperationType M_type;
        };

}

#endif
