#include "cond_game_situation.h"

#include <setplay/model/ivisitor.h>

namespace setplay {

    CondGameSituation::CondGameSituation(GameSituation* game_situation )
        : M_game_situation(game_situation)
    {

    }

    CondGameSituation::CondGameSituation(const CondGameSituation& other )
    {
        M_game_situation = other.M_game_situation != NULL ? new GameSituation( *other.M_game_situation ) : NULL;
    }

    CondGameSituation::~CondGameSituation()
    {
        if ( M_game_situation != NULL )
        {
            delete M_game_situation;
        }
    }

    TokenType CondGameSituation::type() const
    {
        return TT_CONDITION_GAME_SITUATION;
    }

    void CondGameSituation::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

    CondGameSituation& CondGameSituation::operator*()
    {
        return *this;
    }

    CondGameSituation* CondGameSituation::clone() const
    {
        return new CondGameSituation( *this );
    }

}
