// -*-c++-*-

/***************************************************************************
                                   cond.h
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef COND_GAME_SITUATION_H
#define COND_GAME_SITUATION_H

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/game_situation.h>

namespace setplay {

    // Check for current Play Mode
    class CondGameSituation
            : public ICondition
    {
    public:
      CondGameSituation(GameSituation* game_situation = NULL );
      CondGameSituation(const CondGameSituation& other);

      ~CondGameSituation();

      TokenType type() const;

      /* class specific stuff */
      GameSituation
      gameSituation() const { return *M_game_situation; }


      inline CondGameSituation& operator=(const CondGameSituation& other)
      {
          if (this != &other)
          {
              this->M_game_situation = other.M_game_situation;
          }
          return *this;
      }

      inline bool operator==(const CondGameSituation& other)
      {
          if (this != &other)
          {
              return M_game_situation == other.M_game_situation;
          }
          return true;
      }


      void visit(IVisitor& visitor);
      CondGameSituation& operator*();
      CondGameSituation* clone() const;
    private:
      GameSituation* M_game_situation;
    };

}

#endif
