#ifndef COND_KICKABLE_H
#define COND_KICKABLE_H

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/participants/iplayer.h>

namespace setplay {

/*!
  \brief Check if the ball is kickable by a player
  */
class CondKickable
        : public ICondition
{
public:
    CondKickable(IPlayer* player = NULL);
    CondKickable(const CondKickable& other);
    ~CondKickable();

    TokenType type() const;

    IPlayer *player() const;
    CondKickable& setPlayer(IPlayer* player);

    CondKickable& operator=(const CondKickable& other);

    void visit(IVisitor &visitor);
    CondKickable* clone() const;
    CondKickable& operator*();
private:
    IPlayer* M_player;
};

}

#endif // COND_KICKABLE_H
