// -*-c++-*-

/***************************************************************************
                                   cond_not.h
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef COND_NOT_H_
#define COND_NOT_H_

#include <setplay/model/conditions/icondition.h>

namespace setplay {

        // Composite condition: logical not
        class CondNot
                : public ICondition {
        public:

          CondNot(ICondition* cond = NULL);
          CondNot(const CondNot& other);

          ~CondNot();

          ICondition *condition() const;

          void setCondition(ICondition* condition);

          CondNot& operator=(const CondNot& other);

          TokenType type() const;
          CondNot* clone() const;
          CondNot& operator*();
          void visit(IVisitor& visitor);
        private:
          ICondition* M_condition;
        };

}

#endif
