// -*-c++-*-

/***************************************************************************
                                   cond.h
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef COND_OBJECT_AT_LOCATION_H
#define COND_OBJECT_AT_LOCATION_H

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/geom/ilocation.h>

namespace setplay {
    class IVisitor;

    // Ball position in a region
    class CondAtLocation : public ICondition
    {
    public:

      CondAtLocation( IMobileObject* object = NULL,
                      ILocation2D* location = NULL);

      CondAtLocation( const CondAtLocation& other );

      ~CondAtLocation();

      TokenType type() const;

      IMobileObject* object() const;
      ILocation2D* location() const;

      CondAtLocation& setObject(IMobileObject* object);
      CondAtLocation& setLocation(ILocation2D* location);

      CondAtLocation& operator=(const CondAtLocation& other);

      CondAtLocation* clone() const;
      CondAtLocation& operator*();
      void visit(IVisitor& visitor);

    private:
      // const IMoveableObject* M_object;
      IMobileObject* M_object;
      ILocation2D* M_location;
    };

}

#endif
