#include "cond_offside.h"

#include <setplay/model/ivisitor.h>

namespace setplay {

CondOffside::CondOffside(IPlayer* player)
    : M_player( player )
{

}

CondOffside::CondOffside(const CondOffside& other)
{
    M_player = other.M_player != NULL
                ? other.M_player->clone()
                : NULL;
}

CondOffside::~CondOffside()
{
    if ( M_player != NULL ) { delete M_player; }
}

IPlayer* CondOffside::player() const
{
    return M_player;
}

CondOffside& CondOffside::setPlayer(IPlayer* player)
{
    return *this;
}


TokenType CondOffside::type() const
{
    return TT_CONDITION_OFFSIDE;
}

CondOffside* CondOffside::clone() const
{
    return new CondOffside( *this );
}

CondOffside& CondOffside::operator*()
{
    return *this;
}

void CondOffside::visit(IVisitor& visitor)
{
    visitor.visit( *this );
}


}
