#ifndef COND_OFFSIDE_H
#define COND_OFFSIDE_H

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/participants/iplayer.h>

namespace setplay
{

/*!
  \brief Class to check if a player is offside
 */

class CondOffside
        : public ICondition
{
public:
    CondOffside(IPlayer* player = NULL);
    CondOffside(const CondOffside& other);
    ~CondOffside();

    IPlayer *player() const;
    CondOffside& setPlayer(IPlayer* player);

    TokenType type() const;
    CondOffside* clone() const;
    CondOffside& operator*();
    void visit(IVisitor& visitor);

private:
    IPlayer* M_player;
};

}
#endif // COND_OFFSIDE_H
