#include "do_while.h"

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/ivisitor.h>

namespace setplay
{

        DoWhile::DoWhile(Players *players, Actions* actions, ICondition* condition)
          : IDirective(players, actions)
          , M_condition( condition )
        {

        }

        DoWhile::DoWhile(const DoWhile& other)
            : IDirective(other)
        {
            M_condition = other.M_condition != NULL ?
                          other.M_condition->clone() : NULL;
        }

        DoWhile::~DoWhile()
        {
            if ( M_condition != NULL )
            {
                delete M_condition;
            }
        }

        TokenType DoWhile::type() const
        {
            return TT_DIRECTIVE_DO_WHILE;
        }

        IDirective::DirectiveType DoWhile::directiveType() const
        {
            return IDirective::DT_DO_WHILE;
        }

        ICondition* DoWhile::condition() const
        {
            return M_condition;
        }

        DoWhile& DoWhile::setCondition( ICondition* condition )
        {
            if ( M_condition != NULL )
            {
                delete M_condition;
            }
            M_condition = condition;
            return *this;
        }

        void DoWhile::visit(IVisitor& visitor)
        {
            visitor.visit( *this );
        }

        DoWhile* DoWhile::clone() const
        {
            return new DoWhile( *this );
        }
}
