#include "circle_2d.h"

#include <setplay/model/ivisitor.h>

namespace setplay {


  Circle2D::Circle2D( IPoint2D* center, IDecimal *radius)
      : M_center(center)
      , M_radius(radius)
  {
      assert( M_center != NULL && M_radius != NULL );
  }

  Circle2D::Circle2D( const Circle2D& other)
      : M_center(other.M_center)
      , M_radius(other.M_radius)
  {

  }

  Circle2D::~Circle2D()
  {
      delete M_center;
      delete M_radius;
  }

  // Accessors
  IPoint2D* Circle2D::center( ) const
  {
      return M_center;
  }

  IDecimal* Circle2D::radius( ) const
  {
      return M_radius;
  }


  Circle2D& Circle2D::setCenter(IPoint2D* point)
  {
      if ( M_center != NULL ) { delete M_center; }
      M_center = point;
      return *this;
  }

  Circle2D& Circle2D::setRadius(IDecimal* decimal)
  {
      if ( M_radius != NULL ) { delete M_radius; }
      M_radius = decimal;
      return *this;
  }

  Circle2D& Circle2D::operator*()
  {
      return *this;
  }

  Circle2D* Circle2D::clone() const
  {
      return new Circle2D(*this);
  }

  void Circle2D::visit(IVisitor& visitor)
  {
      visitor.visit( *this );
  }

}
