// -*-c++-*-

#ifndef SP_LOCATION_VAR_H
#define SP_LOCATION_VAR_H

#include <setplay/model/variable.h>
#include <setplay/model/geom/ipoint.h>
#include <setplay/model/geom/iregion.h>

namespace setplay {

    class VarLocation
            : public IPoint2D
            , public Variable
    {
    public:
        VarLocation( const string &name );
        VarLocation( const VarLocation& other );

        TokenType type() const;
        LocationType locationType() const;

        VarLocation& operator*();
        VarLocation* clone() const;
        void visit(IVisitor& visitor);
    };

    class VarRegion
            : public IRegion2D
            , public Variable
    {
    public:
        VarRegion( const string &name );
        VarRegion( const VarRegion& other );

        TokenType type() const;
        LocationType locationType() const;

        VarRegion& operator*();
        VarRegion* clone() const;
        void visit(IVisitor& visitor);
    };

    class VarPoint
            : public IPoint2D
            , public Variable
    {
    public:
        VarPoint( const string &name );
        VarPoint( const VarPoint& other );

        TokenType type() const;
        LocationType locationType() const;

        VarPoint& operator*();
        VarPoint* clone() const;
        void visit(IVisitor& visitor);
    };
}

#endif
