#ifndef SP_RAY2D_H
#define SP_RAY2D_H

#include <setplay/model/geom/ilocation.h>

namespace setplay {
    class IContextProvider;
    class IDecimal;
    class IPoint2D;
    class IVisitor;

    class Ray2D
            : public ILocation2D {
    public:
        Ray2D(IPoint2D *origin = NULL, IDecimal *direction = NULL);
        Ray2D(const Ray2D& other);

        TokenType type() const;
        LocationType locationType() const;

        /// Accessors
        IPoint2D* origin() const;
        IDecimal* direction() const;

        /// Modifiers
        Ray2D& setOrigin(IPoint2D* origin);
        Ray2D& setDirection(IDecimal* direction);
        Ray2D& operator=(const Ray2D& other);

        Ray2D& operator*();
        Ray2D* clone() const;
        void visit(IVisitor& visitor);
    private:
        IPoint2D* M_origin;
        //! ray's direction.
        IDecimal* M_direction;
    };

}

#endif
