#include "number_var.h"

namespace setplay {

    /// VarInteger class implementation

    VarInteger::VarInteger(const string name)
        : Variable(name)
    {

    }

    VarInteger::VarInteger(const VarInteger& other)
        : Variable( other )
    {

    }

    TokenType VarInteger::type() const
    {
        return TT_VAR_DECIMAL;
    }

    void VarInteger::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }


    VarInteger* VarInteger::clone() const
    {
        return new VarInteger( *this );
    }

    VarInteger& VarInteger::operator*()
    {
        return *this;
    }

    /// VarDecimal class implementation

    VarDecimal::VarDecimal(const string name)
        : Variable(name)
    {

    }

    VarDecimal::VarDecimal(const VarDecimal& other)
        : Variable( other )
    {

    }

    TokenType VarDecimal::type() const
    {
        return TT_VAR_DECIMAL;
    }

    void VarDecimal::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }


    VarDecimal* VarDecimal::clone() const
    {
        return new VarDecimal( *this );
    }

    VarDecimal& VarDecimal::operator*()
    {
        return *this;
    }

}
