#ifndef FUNCTOR_TEAM_H
#define FUNCTOR_TEAM_H

#include <setplay/model/types.h>
#include <setplay/model/participants/iplayer.h>
#include <cassert>

namespace setplay
{

class FunctorTeam
{
public:
    virtual ~FunctorTeam() { }

    virtual TeamAffiliation operator()() = 0;
};


/*!
  \brief Determine the affiliation of a given player
  \abstract Useful when combined with other predicates such as NearestPlayer
*/
class PlayerTeamAffiliation
        : public FunctorTeam
{
public:
    PlayerTeamAffiliation(IPlayer* player = NULL)
        : M_player( player )
    {
        assert( false ); // TODO Non usable
    }


private:
    IPlayer* M_player;
};



}

#endif // FUNCTOR_TEAM_H
