// -*-c++-*-

#ifndef SP_PLAYER_ID_H
#define SP_PLAYER_ID_H

#include <vector>
#include <map>

#include <setplay/model/participants/iplayer.h>
#include <setplay/model/types.h>

using namespace std;

namespace setplay {


    class PlayerAffiliation
            : public IPlayer
    {
    public:
      // number 0 stands for all players
      PlayerAffiliation(unsigned int number, TeamAffiliation affiliation);
      PlayerAffiliation(const PlayerAffiliation& other);
      ~PlayerAffiliation();

      TeamAffiliation affiliation() const;
      unsigned int number() const;


      TokenType type() const;
      PlayerType playerType() const;

      bool operator==(const PlayerAffiliation& other) const;
      bool operator!=(const PlayerAffiliation& other) const;

      PlayerAffiliation* clone() const;
      void visit(IVisitor& visitor);

    private:
      TeamAffiliation M_affiliation;
      unsigned int M_number;
    };

    /// IPlayerID comparator for usage with std::map
    struct IPlayerIDComparator
    {
        bool operator()(const PlayerAffiliation* p1, const PlayerAffiliation* p2) const;
    };

    typedef std::map<const PlayerAffiliation*, const PlayerAffiliation*, IPlayerIDComparator > PlayersMapping;
}
#endif
