#include "player_var.h"

#include <setplay/model/ivisitor.h>

namespace setplay {


    VarPlayer::VarPlayer(const string name)
        : Variable(name)
    {

    }

    VarPlayer::VarPlayer(const VarPlayer& other)
        : Variable(other)
    {

    }

    TokenType VarPlayer::type() const
    {
        return TT_VAR_PLAYER;
    }

    IPlayer::PlayerType VarPlayer::playerType() const
    {
        return IPlayer::PT_PlayerVar;
    }

    void VarPlayer::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

    VarPlayer* VarPlayer::clone() const
    {
        return new VarPlayer(*this);
    }

}
