#ifndef REWRITE_RULE_H
#define REWRITE_RULE_H

#include <setplay/model/object.h>

namespace setplay {
    class SetplayInterpreter;

    class RewriteRule
    {
    public:
        virtual ~RewriteRule() { }

        virtual bool accepts(const Object& setplay_concept) = 0;

        virtual Object* rewrite(const Object& setplay_concept) = 0;
    };

    class RewritePlayerPosition
            : public RewriteRule
    {
    public:
        RewritePlayerPosition(SetplayInterpreter* interpreter);

        bool accepts(const Object& setplay_concept);

        Object* rewrite(const Object& setplay_concept);
    private:
        SetplayInterpreter* M_interpreter;
    };


    class RewriteBallPosition
            : public RewriteRule
    {
    public:
        RewriteBallPosition(SetplayInterpreter* interpreter);

        bool accepts(const Object& setplay_concept);

        Object* rewrite(const Object& setplay_concept);
    private:
        SetplayInterpreter* M_interpreter;
    };


    class RewriteDecimalBinaryOperation
            : public RewriteRule
    {
    public:
        RewriteDecimalBinaryOperation(SetplayInterpreter* interpreter);

        bool accepts(const Object& setplay_concept);

        Object* rewrite(const Object& setplay_concept);
    private:
        SetplayInterpreter* M_interpreter;
    };


    class RewriteDynamicPlayer
            : public RewriteRule
    {
    public:
        RewriteDynamicPlayer(SetplayInterpreter* interpreter);

        bool accepts(const Object& setplay_concept);

        Object* rewrite(const Object& setplay_concept);
    private:
        SetplayInterpreter* M_interpreter;
    };

    /*!
      \brief Rewrite CondWaitTime as CondComp
      */
    class RewriteCondWaitTime
            : public RewriteRule
    {
    public:
        RewriteCondWaitTime(SetplayInterpreter* interpreter);

        bool accepts(const Object& setplay_concept);

        Object* rewrite(const Object& setplay_concept);
    private:
        SetplayInterpreter* M_interpreter;
    };

}

#endif // REWRITE_RULE_H
