#include "types.h"

namespace setplay {

    /// Bool implementation
	Bool::Bool( bool value )
		: M_value( value )
	{

	}	

    Bool::Bool(const Bool&other)
		: M_value(other.M_value)
	{

	}

    Bool::~Bool()
	{

	}


    TokenType Bool::type() const
    {
        return TT_BOOL;
    }

    bool Bool::value() const
	{
		return M_value;
	}
 
	Bool& Bool::setValue(bool value)
	{
		M_value = value;
        return *this;
	}

    bool Bool::operator==(const Bool& other)
    {
        return M_value == other.M_value;
    }

    bool Bool::operator!=(const Bool& other)
    {
        return !(*this == other);
    }


    Bool& Bool::operator=(const Bool& other)
	{
        M_value = other.M_value;
        return *this;
	}

    Bool* Bool::clone() const
	{
		return new Bool( *this );
	}
                    
	void Bool::visit(IVisitor& visitor)
	{
		visitor.visit( *this );
	}


    /// Integer implementation
    Integer::Integer( int value )
        : Number( value )
    {

    }

    Integer::Integer(const Integer&other)
        : Number( other )
    {

    }

    Integer::~Integer()
    {

    }

    TokenType Integer::type() const
    {
        return TT_INTEGER;
    }

    Integer* Integer::clone() const
    {
        return new Integer( *this );
    }

    Integer& Integer::operator*()
    {
        return *this;
    }

    void Integer::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

    /// Decimal implementation
    Decimal::Decimal( float value )
        : Number( value )
    {

    }

    Decimal::Decimal(const Decimal& other)
        : Number( other )
    {

    }

    Decimal::~Decimal()
    {

    }

    TokenType Decimal::type() const
    {
        return TT_DECIMAL;
    }

    Decimal* Decimal::clone() const
    {
        return new Decimal( *this );
    }

    Decimal& Decimal::operator*()
    {
        return *this;
    }

    void Decimal::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

}
