#include "setplay_database.h"

using namespace std;

namespace setplay {

SetplayDatabase::SetplayDatabase()
{

}

SetplayDatabase::~SetplayDatabase()
{
    for ( Setplays::iterator it = M_setplays.begin();
          it != M_setplays.end(); it++)
    {
        delete it->second;
    }
}

bool SetplayDatabase::contains(unsigned int id) const
{
    return M_setplays.find( id ) != M_setplays.end();
}

Setplay* SetplayDatabase::getSetplay(unsigned int id) const
{
    assert ( contains(id) );

    return M_setplays.at(id);
}

unsigned int SetplayDatabase::count() const
{
    return M_setplays.size();
}

const Setplays& SetplayDatabase::setplays() const
{
    return M_setplays;
}

void SetplayDatabase::add(Setplay* setplay)
{
    assert ( setplay != NULL && !contains(setplay->id()));

    M_setplays.insert(pair<unsigned int, Setplay*>(setplay->id(), setplay));
}

bool SetplayDatabase::remove(unsigned int id)
{
    assert( contains(id) );

    // Free set-play memory
    M_setplays.erase( id ); // Calls elements destructor
}

void SetplayDatabase::clear()
{
    M_setplays.clear();
}

}
