#ifndef SETPLAY_MANAGER_CBR_H
#define SETPLAY_MANAGER_CBR_H

#include <setplay/runtime/setplay_mediator.h>
#include <setplay/cbr.h>

namespace setplay {

    class SetplayManagerCBR
            : public SetplayMediator
    {
    public:
        SetplayManagerCBR(const IPlayerID& self,
                          const string cbrFile,
                          bool writeCBRToFile,
                          bool writeCBRToFileAfterExecution,
                          double weightThisGame,
                          double weightThisTeam,
                          double weightOtherTeams,
                          bool useComm,
                          bool limitedComm,
                          unsigned int messageRepeatTime);
      ~SetplayManagerCBR();

      unsigned int
      selectSetplayByCBR( vector<CaseBase::SetplayID>& possibleSetplays,
                          const IWorldModel& world ) const;

      void activate_setplay( const InitMessage& init,
                             const IWorldModel& world);

      void autoActivateSetplay( const IWorldModel& observer,
                                const IConditionEvaluator& evaluator );

      virtual void handle_setplay_end( const IWorldModel& world );

    private:
      // for CBR
      const IPoint2D* M_ball_initial_position; // for CBR
      PlayMode M_playmode;

      CaseBase* M_case_base;
      CaseBase M_game_case_base;
    };

}

#endif // SETPLAY_MANAGER_CBR_H
