// -*-c++-*-
#ifndef SP_UTIL_H
#define SP_UTIL_H

#include <vector>
#include <iostream>

namespace setplay {

    typedef enum { //LMOTA
      //Some new playmodes were introduced due to usage
      // in the midsize league, namely all the After modes...
      None,
      BeforeKickOff,
      TimeOver,
      PlayOn,
      KickOff_Our,
      KickOff_Our_After,
      KickOff_Opp,
      KickOff_Opp_After,
      KickIn_Our,
      KickIn_Our_After,
      KickIn_Opp,
      KickIn_Opp_After,
      FreeKick_Our,
      FreeKick_Our_After,
      FreeKick_Opp,
      FreeKick_Opp_After,
      Ind_FreeKick_Our,
      Ind_FreeKick_Our_After,
      Ind_FreeKick_Opp,
      Ind_FreeKick_Opp_After,
      CornerKick_Our,
      CornerKick_Our_After,
      CornerKick_Opp,
      CornerKick_Opp_After,
      GoalKick_Our,
      GoalKick_Our_After,
      GoalKick_Opp,
      GoalKick_Opp_After,
      GoalieCatch_Our,
      GoalieCatch_Opp,
      AfterGoal_Our,
      AfterGoal_Opp,
      Invalid
    } PlayMode;


    /*static const unsigned short MODE_STRINGS_LENGTH=33;

    static const char* MODE_STRINGS[] = {
      "",
      "bko",
      "time_over",
      "play_on",
      "ko_our",
      "ko_our_after",
      "ko_opp",
      "ko_opp_after",
      "ki_our",
      "ki_our_after",
      "ki_opp",
      "ki_opp_after",
      "fk_our",
      "fk_our_after",
      "fk_opp",
      "fk_opp_after",
      "ifk_our",
      "ifk_our_after",
      "ifk_opp",
      "ifk_opp_after",
      "ck_our",
      "ck_our_after",
      "ck_opp",
      "ck_opp_after",
      "gk_our",
      "gk_our_after",
      "gk_opp",
      "gk_opp_after",
      "gc_our",
      "gc_opp",
      "ag_our",
      "ag_opp",
      "invalid" };


    std::ostream& operator<<( std::ostream & os, const PlayMode& s )
    {
      return os << MODE_STRINGS[s];
    }*/

    //struct used as element in next procedure
    struct PlayerNumAndDistance{
      std::vector<unsigned int>* playerNums;
      float totalDist;

     PlayerNumAndDistance():playerNums(new std::vector<unsigned int>),totalDist(0){}
     PlayerNumAndDistance(std::vector<unsigned int>* playerNums_,float totalDist_):
      playerNums(playerNums_),totalDist(totalDist_){}
    };

    // std::ostream& operator<<( std::ostream & os, const PlayerNumAndDistance& e );

    // Procedure that receives a PlayerNumAndDistance vector v1
    // and a PlayerNumAndDistance v2.  v2 will be
    // appended to each element in v1. Distances will be summed.
    // All these elements will be returned. If any element in v2
    // is present in an element of v1, this element will be discarded
    std::vector<PlayerNumAndDistance>*
    appendToVector(const std::vector<PlayerNumAndDistance>& v1,
                   const PlayerNumAndDistance& v2);


    // Check if an element is contained in a vector
    bool containedInVector(unsigned int e,std::vector<unsigned int> v);
    // factorial
    unsigned int fact(unsigned int num);

}


#endif // SP_UTIL_H
