#include <setplay/model/setplay.h>
#include <setplay/model/conditions.h>

#include <setplay/generators/sexpr/setplay_generator_sexpr.h>

#include <cstdlib>
#include <limits>
#include <sstream>

using namespace std;
using namespace setplay;

#define MIN_PARAMETERS 0
#define MAX_PARAMETERS 6

static const char* letters = { "abcdefghijklmnopqrstuvwxyz" };
static const unsigned int num_letters = 26;

// Forward declarations
double randomValue(double lowest, double highest);
ICondition* randomCondition();
unsigned int randomUnsignedInt();
std::string randomString();

int main( int argc, char** argv)
{
    srand((unsigned)time(0));

    Setplay sp;
    sp.setAbortCondition( randomCondition() );
    sp.setStartCondition( randomCondition() );
    sp.setId( randomUnsignedInt() );
    sp.setName( randomString() );


    SetplayGeneratorSexpr sexpr(std::cout);
    sp.visit( sexpr );
}


double randomValue(double lowest, double highest)
{
    double range = (highest-lowest) + 1;
    return ( lowest + range*rand() / (RAND_MAX + 1.0));
}

ICondition* randomCondition()
{
    return new CondOffside();
}

unsigned int randomUnsignedInt()
{
   unsigned int lowest = numeric_limits<unsigned int>::min();
   unsigned int highest = numeric_limits<unsigned int>::max();

   return (unsigned int) randomValue( lowest, highest );
}

std::string randomString()
{
   unsigned int size = (unsigned int) randomValue( 0, 32 );

   std::stringstream ss;
   for ( unsigned int i = 0; i < size; i++ )
   {
       ss << letters[ (unsigned int) randomValue( 0, num_letters - 1) ];
   }

   return ss.str();
}


