#include "ball_dispute.h"

#include "ievent_visitor.h"

namespace soccer {
namespace event {

BallDispute::BallDispute(unsigned int start_time)
    : Event( start_time )
{

}

BallDispute::BallDispute(unsigned int start_time, unsigned int end_time, std::vector<PlayerId> players)
    : Event(start_time, end_time)
    , M_kickers(players)
{

}

IEvent::EventType BallDispute::type() const
{
    return IEvent::BallDispute;
}

const std::vector<PlayerId>& BallDispute::players() const
{
    return M_kickers;
}

void BallDispute::addPlayer(PlayerId player)
{
    M_kickers.push_back( player );
}

void BallDispute::visit(IEventVisitor& visitor) const
{
    visitor.visit( *this );
}

}
}
