#ifndef BALL_MOVE_H
#define BALL_MOVE_H

#include <soccer/events/event.h>
#include <rcsc/geom/vector_2d.h>

namespace soccer
{
	namespace event
	{

		class BallMove: public Event {
		public:
            BallMove(unsigned int start_time, unsigned int end_time);
					   
            EventType type() const;
			rcsc::Vector2D from() const;
			rcsc::Vector2D to() const;
			
            BallMove& setTo(rcsc::Vector2D to);
            BallMove& setFrom(rcsc::Vector2D from);

            void visit(IEventVisitor& visitor) const;
		private:
			rcsc::Vector2D M_from;
			rcsc::Vector2D M_to;
		
		};
	
	}
}

#endif
