#include "goal_pass_chain.h"
#include "ievent_visitor.h"

namespace soccer {
namespace event {

GoalPassChain::GoalPassChain()
{

}

GoalPassChain::GoalPassChain( const std::vector< std::tr1::shared_ptr<IEvent> >& events)
    : EventChain(events)
{

}

GoalPassChain::GoalPassChain(const GoalPassChain& goal_pass_chain)
    : EventChain(goal_pass_chain)
{

}

IEvent::EventType GoalPassChain::type() const
{
    return IEvent::GoalPassChain;
}

void GoalPassChain::visit(IEventVisitor& visitor) const
{
    visitor.visit( *this );
}

}
}
