#include "goalie_catch.h"

#include <soccer/events/ievent_visitor.h>

namespace soccer {
namespace event {

    GoalieCatch::GoalieCatch(unsigned int time, TeamSide team_side)
        : Event(time)
        , M_team_side(team_side)
    {

    }

    IEvent::EventType GoalieCatch::type( ) const
    {
        return IEvent::GoalieCatch;
    }

    TeamSide GoalieCatch::teamSide() const
    {
        return M_team_side;
    }

    void GoalieCatch::visit(IEventVisitor &visitor) const
    {
        visitor.visit( *this );
    }

}
}
