#ifndef IEVENT_VISITOR_H
#define IEVENT_VISITOR_H

#include "events.h"

#include <tr1/memory>

namespace soccer
{
	namespace event
	{
		/*
			\brief Interface for to output events to an output stream
		*/
        class IEventVisitor {
		public:
            virtual ~IEventVisitor() { }
			
            virtual void visit(const KickOff& event) = 0;
            virtual void visit(const KickOffTaken& event) = 0;
            virtual void visit(const ThrowIn& event) = 0;
            virtual void visit(const ThrowInTaken& event) = 0;
            virtual void visit(const GoalKick& event) = 0;
            virtual void visit(const GoalKickTaken& event) = 0;
            virtual void visit(const CornerKick& event) = 0;
            virtual void visit(const CornerKickTaken& event) = 0;
            virtual void visit(const FreeKick& event) = 0;
            virtual void visit(const FreeKickTaken& event) = 0;
            virtual void visit(const IndirectFreeKick& event) = 0;
            virtual void visit(const IndirectFreeKickTaken& event) = 0;
			
            virtual void visit(const Goal& event) = 0;

            virtual void visit(const SoccerMomentChanged& event) = 0;
            virtual void visit(const PossessionChanged& event) = 0;
			
            virtual void visit(const Shoot& event) = 0;
            virtual void visit(const Dribble& event) = 0;
            virtual void visit(const Pass& event) = 0;

            virtual void visit(const Interception& event) = 0;
            virtual void visit(const Turnover& event) = 0;

            virtual void visit(const PlayerMove& event) = 0;

            virtual void visit(const GoalieCatch& event) = 0;
            virtual void visit(const BallKick& event) = 0;
            virtual void visit(const BallDispute& event) = 0;
            virtual void visit(const BallMove& event) = 0;
            virtual void visit(const BallHold& event) = 0;
			
            virtual void visit(const Offside& event) = 0;
		
            /// Cooperative events
            virtual void visit(const PassChain& event) = 0;
            virtual void visit(const GoalPassChain& event ) = 0;
		};

	}
}

#endif
