#include "kick_off_taken.h"
#include "ievent_visitor.h"

namespace soccer
{
    namespace event
    {

        KickOffTaken::KickOffTaken(unsigned int start_time, TeamSide side)
            : Event(start_time)
            , M_side(side)
        {

        }

        IEvent::EventType KickOffTaken::type() const
        {
            return IEvent::KickOffTaken;
        }

        TeamSide KickOffTaken::side() const
        {
            return M_side;
        }

        void KickOffTaken::visit(IEventVisitor& visitor) const
        {
            visitor.visit( *this );
        }

    }
}
