#include "offside.h"
#include "ievent_visitor.h"

using namespace std;

namespace soccer
{
	namespace event
	{

        Offside::Offside(unsigned int start_time, TeamSide side)
            : Event(start_time)
            , M_side(side)
		{

		}

        void Offside::addPlayer( unsigned int number )
        {
            M_players.push_back( number );
        }

        IEvent::EventType Offside::type() const
        {
            return IEvent::Offside;
        }

        TeamSide Offside::side() const
		{
            return M_side;
        }

        const vector<unsigned int>& Offside::players() const
        {
            return M_players;
        }
		
        void Offside::visit(IEventVisitor& visitor) const
		{
			visitor.visit( *this );
		}
			
	}
}
