#ifndef PASS_H
#define PASS_H

#include <soccer/events/event.h>
#include <soccer/player_id.h>

namespace soccer
{
	namespace event
	{
		
        class Pass
                : public Event {
		public:
			Pass(unsigned int start_time, unsigned int end_time,
                 TeamSide team_side,
                 soccer::Unum sender,
                 soccer::Unum receiver);
			
            EventType type() const;
            TeamSide teamSide() const;
            soccer::Unum sender() const;
            soccer::Unum receiver() const;

            void visit(IEventVisitor& visitor) const;
		private:
            TeamSide M_team_side;
            unsigned int M_sender;
            unsigned int M_receiver;
		};
	
	}
}

#endif
