#ifndef SIMPLE_EVENT_WRITER_H
#define SIMPLE_EVENT_WRITER_H

#include <soccer/events/ievent_visitor.h>
#include <string>
#include <fstream>

namespace soccer
{
	namespace event
	{
		/*
			\brief Interface to output& events to an output stream
		*/
        class SimpleEventWriter
                : public IEventVisitor {
		public:
            SimpleEventWriter(std::ostream& os);
			
            void visit(const KickOff& event);
            void visit(const KickOffTaken& event);
            void visit(const ThrowIn& event);
            void visit(const ThrowInTaken& event);
            void visit(const GoalKick& event);
            void visit(const GoalKickTaken& event);
            void visit(const CornerKick& event);
            void visit(const CornerKickTaken& event);
            void visit(const FreeKick& event);
            void visit(const FreeKickTaken& event);
            void visit(const IndirectFreeKick& event);
            void visit(const IndirectFreeKickTaken& event);

            void visit(const SoccerMomentChanged& event);
            void visit(const PossessionChanged& event);

            void visit(const Interception& event);
            void visit(const Turnover& event);

            void visit(const GoalieCatch& event);
            void visit(const BallKick& event);
            void visit(const BallDispute& event);
            void visit(const BallHold& event);

            void visit(const Goal& event);
			
            void visit(const Shoot& event);
            void visit(const Dribble& event);
            void visit(const BallMove& event);
            void visit(const PlayerMove& event);
            void visit(const Pass& event);
			
            void visit(const Offside& event);

            void visit(const PassChain& event);
            void visit(const GoalPassChain& event);
			
		private:

            void printTime(std::string label,
                           const IEvent& event);
            std::ostream& M_os;
			
		};

	}
}

#endif
