#include "throw_in_taken.h"
#include "ievent_visitor.h"

namespace soccer {
    namespace event {

        ThrowInTaken::ThrowInTaken(unsigned int start_time, TeamSide side)
            : Event(start_time )
            , M_side(side)
        {

        }

        IEvent::EventType ThrowInTaken::type() const
        {
            return IEvent::ThrowInTaken;
        }

        TeamSide ThrowInTaken::side() const
        {
            return M_side;
        }

        void ThrowInTaken::visit(IEventVisitor& visitor) const
        {
            visitor.visit( *this );
        }

    }
}
