#include "game_mode.h"

#include <sstream>
#include <cassert>

using namespace std;

namespace soccer
{

GameMode::GameMode(GameSituation game_situation, unsigned int time)
    : M_game_situation(game_situation)
    , M_time(time)
{

}

GameMode::GameMode(const GameMode& other)
    : M_game_situation(other.M_game_situation)
    , M_time(M_time)
{

}

GameSituation GameMode::gameSituation() const
{
    return M_game_situation;
}

unsigned int GameMode::time() const
{
    return M_time;
}

GameMode& GameMode::operator=(const GameMode& rhs)
{
    // Check for self-assignment!
    if (this == &rhs)      // Same object?
      return *this;        // Yes, so skip assignment, and just return *this.

    M_game_situation = rhs.M_game_situation;
    M_time = rhs.M_time;

    return *this;
}

}


