#ifndef PLAYER_H
#define PLAYER_H

#include "imoving_object.h"
#include <soccer/player_id.h>

namespace soccer {

class Player
        : public PlayerId
        , public IMovingObject {
public:
    typedef enum {
        VQ_LOW,
        VQ_HIGH,
        VQ_UNKNOWN
    } ViewQuality;

    typedef enum {
        VW_NARROW,
        VW_NORMAL,
        VW_WIDE,
        VW_UNKNOWN
    } ViewWidth;

    Player(Unum number, TeamSide side,
	       rcsc::Vector2D position,
           rcsc::Vector2D velocity,
           float body_dir,
           float neck_dir,
           bool goalie = false);
	
    bool isGoalie() const;
    float bodyDir() const;
    float neckDir() const;


    /*ViewWidth viewWidth() const;
    ViewQuality viewQuality() const;
    float stamina() const;
    float staminaCapacity() const;
    float recovery() const;
    float effort() const;*/
private:
        Unum M_number;
        TeamSide M_side;
        float M_body_dir; //!< body direction (degree)
        float M_neck_dir; //!< head direction relative to body (degree)
        bool M_goalie;


        /*rcsc::Vector2D M_arm_point; //!< arm pointing position
        ViewQuality M_view_quality; //!< view quality
        ViewWidth M_view_width; //!< view width

        float M_stamina; //!< stamina value
        float M_effort; //!< effort value
        float M_recovery; //!< recovery value
        float M_stamina_capacity; //!< stamina capacity
        */
	
		
};

}

#endif
