#include "player_affiliation.h"

namespace soccer {

PlayerAffiliation::PlayerAffiliation(unsigned int number, TeamAffiliation affiliation)
    : M_number(number)
    , M_affiliation(affiliation)
{

}

PlayerAffiliation::PlayerAffiliation(const PlayerAffiliation& other)
    : M_number(other.M_number)
    , M_affiliation(other.M_affiliation)
{

}

unsigned int PlayerAffiliation::number() const
{
    return M_number;
}

TeamAffiliation PlayerAffiliation::affiliation() const
{
    return M_affiliation;
}

PlayerAffiliation& PlayerAffiliation::operator=(const PlayerAffiliation& other)
{
    if ( this != &other )
    {
        this->M_number = other.M_number;
        this->M_affiliation = other.M_affiliation;
    }

    return *this;
}


bool PlayerAffiliation::operator==(const PlayerAffiliation& other) const
{
    return M_number == other.M_number && M_affiliation == other.M_affiliation;
}

bool PlayerAffiliation::operator!=(const PlayerAffiliation& other) const
{
    return !(*this == other);
}

bool PlayerAffiliation::operator<(const PlayerAffiliation& other) const
{
    if ( M_affiliation != other.M_affiliation )
    {
        return M_affiliation == TA_OUR ? true : false;
    }

    return this->M_number < other.M_number;
}

bool PlayerAffiliation::operator>(const PlayerAffiliation& other) const
{
    return ! (*this < other);
}

}
