#ifndef PLAYER_ID_H
#define PLAYER_ID_H

#include <soccer/iplayer_id.h>

namespace soccer
{

        class PlayerId: public IPlayer {
        public:

            PlayerId(Unum number, TeamSide side, bool goalie = false);
            PlayerId(const PlayerId& other);

            // Override interface methods
            Unum number() const;
            TeamSide side() const;
            bool isGoalie() const;

            // Operator overload
            PlayerId& operator=(const PlayerId& other);
            bool operator==(const PlayerId& other) const;
            bool operator!=(const PlayerId& other) const;
            bool operator<(const PlayerId& other) const;
            bool operator>(const PlayerId& other) const;

        private:
            bool M_goalie;
            unsigned int M_number;
            TeamSide M_side;
        };


}

#endif
