#ifndef FCPORTUGAL_FLUX_DT_H
#define FCPORTUGAL_FLUX_DT_H

#include "flux.h"

#include <sstream>

#include <rcsc/common/logger.h>
#include <rcsc/geom/rect_2d.h>
#include <rcsc/geom/delaunay_triangulation.h>

#include <strategy/util.h>


namespace soccer
{
    namespace flux
    {

        class FluxDT: public Flux
        {
        public:

            FluxDT(const rcsc::Rect2D& bounding_rect);
            ~FluxDT();

            FluxType type() const;

            // This should be separated from this class, but for now it will stay here
            bool read(std::istream& is);

            double value(const rcsc::Vector2D& position) const;

            void update(const IWorldModel* );
        private:
            rcsc::DelaunayTriangulation M_triangulation;
            double* M_flux_values;
        };

    }
}

#endif // FCPORTUGAL_FLUX_DT_H
