#ifndef FORMATION_SELECTOR_H
#define FORMATION_SELECTOR_H

#include <vector>
#include <soccer/iworld_model.h>

namespace soccer {

class IWorldModel;

namespace formation {

class Formation;

class IFormationSelector
{
public:
    virtual ~IFormationSelector() { }

    virtual unsigned int formation() const = 0;
};

class SituationFormationSelector
        : public IFormationSelector
{
public:
    SituationFormationSelector();

    void addFormation( GameSituation game_situation, unsigned int formation_id );
    unsigned int formation() const;
private:
    typedef std::map<soccer::GameSituation, unsigned int> GameSituationFormations;

    GameSituationFormations M_formations;
    const soccer::IWorldModel* M_world_model;
};

}
}
#endif // FORMATION_SELECTOR_H
