#ifndef FCPORTUGAL_STRATEGY_UTIL_H
#define FCPORTUGAL_STRATEGY_UTIL_H

#include <vector>
#include <string>
#include <iostream>

#include <rcsc/geom.h>

namespace soccer {
namespace strategy {
namespace util {
    std::string getNextLine(std::istream& is);

    rcsc::Vector2D interpolate(const rcsc::Vector2D& ball_position,
                               const rcsc::Vector2D& vertex0_ball_position,
                               const rcsc::Vector2D& vertex1_ball_position,
                               const rcsc::Vector2D& vertex2_ball_position,
                               const rcsc::Vector2D& vertex0_triangle_position,
                               const rcsc::Vector2D& vertex1_triangle_position,
                               const rcsc::Vector2D& vertex3_triangle_position);

    bool tokenizeConfigFile(const std::string& config_file,
                            std::vector<std::string>& args);

}
}
}


#endif // FCPORTUGAL_UTIL_H
